package com.xynet.marketing.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.Promotion;
import com.xynet.marketing.mapper.PromotionMapper;
import com.xynet.marketing.service.PromotionService;
import com.xynet.marketing.utils.Emptys;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 促销活动 服务
 * @author hechunping
 * @date 2025/1/21
 */
@Service
@Slf4j
public class PromotionServiceImpl extends ServiceImpl<PromotionMapper, Promotion> implements PromotionService {
    private LambdaQueryWrapper<Promotion> commonQueryWrapper(JMap<String, Object> param) {
        LambdaQueryWrapper<Promotion> lqw = new LambdaQueryWrapper<Promotion>()
                .eq(Emptys.check(param.getInt("id")), Promotion::getId, param.getInt("id"));
        return lqw;
    }

    @Override
    public Map<String, Object> obj(JMap<String, Object> param) {
        LambdaQueryWrapper<Promotion> lqw = commonQueryWrapper(param).last("limit 1");
        Promotion obj = getOne(lqw);
        return JHashMap.copy(obj);
    }

    @Override
    public Integer saveOrUpdate(JMap<String, Object> param) {
        Promotion save = BeanUtil.copyProperties(param, Promotion.class);
        if (Emptys.check(save.getId())) {
            updateById(save);
        } else {
            save(save);
        }
        return save.getId();
    }

    @Override
    public List<Map<String, Object>> list(JMap<String, Object> param) {
        LambdaQueryWrapper<Promotion> lqw = commonQueryWrapper(param).orderByAsc(Promotion::getId);
        List<Promotion> list = list(lqw);
        return JHashMap.copy(list);
    }

    @Override
    public Page<Map<String, Object>> page(JMap<String, Object> param) {
        LambdaQueryWrapper<Promotion> lqw = commonQueryWrapper(param).orderByAsc(Promotion::getId);
        Page<Promotion> page = new Page<>(param.getInt("pageCurrent"), param.getInt("pageSize"), true);
        Page<Promotion> list = page(page, lqw);
        return JHashMap.copy(list);
    }
}
